// Statistics.java

package uk.org.redfelineninja.risk;

/**
 * Numerical calculator for odds of winning battles in Risk.
 */
public class Statistics {
    private int att, def;

    public Statistics() {
        att = def = 0;
    } // constructor()

    public void score(int[] die, int attNo) {
        int i;
        int a[], d[];

        a = new int[3];
        d = new int[2];

        for (i = 0; i < attNo; i++) {
            a[i] = die[i];
        }

        for (i = attNo; i < die.length; i++) {
            d[i - attNo] = die[i];
        }

        if (a[0] < a[1]) {
            i = a[0];
            a[0] = a[1];
            a[1] = i;
        }

        if (a[1] < a[2]) {
            i = a[1];
            a[1] = a[2];
            a[2] = i;
        }

        if (a[0] < a[1]) {
            i = a[0];
            a[0] = a[1];
            a[1] = i;
        }

        if (d[0] < d[1]) {
            i = d[0];
            d[0] = d[1];
            d[1] = i;
        }

        if (a[0] > d[0])
            att++;
        else
            def++;

        if (Math.min(a[1], d[1]) != 0) {
            if (a[1] > d[1])
                att++;
            else
                def++;
        }
    } // score( int [], int )

    public String toString() {
        return "Attacker = " + att + "; Defender = " + def;
    }

    public static int[] roll(int no) {
        int[] die = new int[no];

        for (int i = 0; i < no; i++) {
            die[i] = ((int) (Math.random() * 6)) + 1;
        }

        return die;
    } // roll( int )

    public static String intArrayToString(int[] a) {
        StringBuffer sb = new StringBuffer("[ ");
        for (int i = 0; i < a.length - 1; i++)
            sb.append(a[i] + ", ");
        sb.append(a[a.length - 1] + " ]");

        return sb.toString();
    } // intArrayToString( int [] )

    public static void main(String argv[]) {
        Statistics s = new Statistics();

        int[] d = new int[5];

        for (d[0] = 1; d[0] <= 6; d[0]++)
            for (d[1] = 1; d[1] <= 6; d[1]++)
                for (d[2] = 1; d[2] <= 6; d[2]++)
                    for (d[3] = 1; d[3] <= 6; d[3]++)
                        for (d[4] = 1; d[4] <= 6; d[4]++)
                            s.score(d, 3);

        System.out.println(intArrayToString(d));
        System.out.println(s);

        s = new Statistics();
        Statistics S = new Statistics();

        d = new int[4];

        for (d[0] = 1; d[0] <= 6; d[0]++)
            for (d[1] = 1; d[1] <= 6; d[1]++)
                for (d[2] = 1; d[2] <= 6; d[2]++)
                    for (d[3] = 1; d[3] <= 6; d[3]++) {
                        s.score(d, 3);
                        S.score(d, 2);
                    }

        System.out.println(intArrayToString(d));
        System.out.println(s);
        System.out.println(S);

    } // main( String [] )

} // Statistics.class
