// Country.java

package uk.org.redfelineninja.risk.robot;

import uk.org.redfelineninja.risk.data.Player;

/**
 * This is a data type representing a Country. It is for manipulation by the
 * GameState and Robot. It is not not classified under data because it
 * exclusivly for robot use.
 * <p>
 * This class stores the majority of the game state information. Each
 * instantionation forms a small part of a web like structure to represent
 * the whole map.
 */
class Country {
    /** The name of a country */
    public final String name;

    /**
     * Inique integer id, this can be used to fetch a country from the game
     * state.
     */
    public final int index;

    /** The player who occupied this country */
    public Player owner;

    /** The number of armies contained within this country */
    public int armies;

    /** List of neighbouring countries */
    public CountryVector neighbors;

    public Country(String n, int i) {
        name = n;
        index = i;

        owner = null;
        armies = 0;

        neighbors = new CountryVector();
    }
} // Country.class
