// <applet code=ImageMapTest.class width=640 height=440></applet>

package uk.org.redfelineninja.test;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.applet.*;
import java.util.*;

import uk.org.redfelineninja.image.*;
import uk.org.redfelineninja.awt.*;

public class ImageMapTest extends Applet implements MouseListener {
    Image map;
    boolean toggle = true;
    ImageMap im;
    HashColorModel cm;

    public void init() {
        setLayout(new BorderLayout());

        Hashtable seedTable = new Hashtable();

        seedTable.put("Alaska", new Point(40, 69));
        seedTable.put("Northwest Territory", new Point(115, 67));
        seedTable.put("Greenland", new Point(285, 52));
        seedTable.put("Alberta", new Point(92, 112));
        seedTable.put("Ontario", new Point(165, 126));
        seedTable.put("Quebec", new Point(231, 130));
        seedTable.put("Western United States", new Point(94, 158));
        seedTable.put("Eastern United States", new Point(169, 171));
        seedTable.put("Central America", new Point(90, 212));

        map = getImage(getDocumentBase(), "map.gif");
        im = new ImageMap(map, seedTable);
        im.addMouseListener(this);

        im.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println(e.getActionCommand());
            }
        });

        add(BorderLayout.CENTER, im);

        Button b = new Button("Toggle");
        b.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                doToggle();
            }
        });

        add(BorderLayout.SOUTH, b);
    }

    private void doToggle() {
        toggle = !toggle;

        if (toggle)
            im.setColor(0xffff00ff);
        else
            im.setColor(0xff00ff00);

        im.paintZone("Alaska");
    }

    java.util.Random rand = new java.util.Random();

    public void mouseClicked(MouseEvent m) {
        Component c = m.getComponent();
        if (c instanceof PixMap) {
            PixMap p = (PixMap) c;

            int i = rand.nextInt();
            p.setColor(0xff00ff00 & i);

            Rectangle r = p.floodFill(m.getX(), m.getY());
            int x = r.x + r.width / 2;
            int y = r.y + r.height / 2;
            String out = "Centre Point: ( " + String.valueOf(x) + ", " + String.valueOf(y) + " )";

            // GraphicsToolkit.centerString( getGraphics(), out, x, y );
            GraphicsToolkit.centerBoxedString(getGraphics(), "10", x, y);
            showStatus(out);
        } // if
    } // mouseClicked

    public void mouseEntered(MouseEvent m) {}
    public void mouseExited(MouseEvent m) {}
    public void mousePressed(MouseEvent m) {}
    public void mouseReleased(MouseEvent m) {}
}
