// javac PixMapTest.java; appletviewer PixMapTest.java
// <applet code=PixMapTest.class width=640 height=440></applet>

package uk.org.redfelineninja.test;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.applet.*;
import uk.org.redfelineninja.awt.*;

public class PixMapTest extends Applet implements MouseListener {
    Image map;
    boolean toggle = true;
    PixMap p;

    public void init() {
        setLayout(new BorderLayout());

        map = getImage(getDocumentBase(), "map.jpg");
        p = new PixMap(map);
        p.drawLine(1, 2, 8, 6);
        p.addMouseListener(this);

        add(BorderLayout.CENTER, p);

        Button b = new Button("Toggle");
        b.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                doToggle();
            }
        });

        add(BorderLayout.SOUTH, b);
    }

    private void doToggle() {
        toggle = !toggle;

        if (toggle)
            p.setColor(0xffff00ff);
        else
            p.setColor(0xff00ff00);

        p.floodFill(40, 40);
        repaint();
    }

    java.util.Random rand = new java.util.Random();

    public void mouseClicked(MouseEvent m) {
        Component c = m.getComponent();
        if (c instanceof PixMap) {
            PixMap p = (PixMap) c;
            int i = rand.nextInt();
            p.setColor(0xff00ff00 & i);
            Rectangle r = p.floodFill(m.getX(), m.getY());
            showStatus(
                "Centre Point: ( " + String.valueOf(r.x + (r.width / 2)) + ", " + String.valueOf(r.y + (r.height / 2)) + " )");
        } // if
    } // mouseClicked

    public void mouseEntered(MouseEvent m) {}
    public void mouseExited(MouseEvent m) {}
    public void mousePressed(MouseEvent m) {}
    public void mouseReleased(MouseEvent m) {}
}
