// StreamTokenizerDemo.java

package uk.org.redfelineninja.test;

import java.io.*;

import uk.org.redfelineninja.util.*;

/**
 * This demo porgram shows the user how a StreamTokenizer might react to
 * data it receives. It takes its data from the standard input. / is a comment
 * and " or ' opens or closes a string.
 *
 * @author Daniel Thompson, Feb. 1999
 */
public class StreamTokenizerDemo {
    public static void main(String[] argv) {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        StreamTokenizer tokenizer = new StreamTokenizer(in);
        tokenizer.eolIsSignificant(true);

        // Hello, good evening and welcome
        System.out.println("Enter any string of characters to see how it will be processed.");

        while (tokenizer.ttype != tokenizer.TT_EOF) {
            try {
                tokenizer.nextToken();
            } catch (IOException e) {
                System.out.println(e);
            }

            if (tokenizer.TT_WORD == tokenizer.ttype) {
                System.out.println("TT_WORD:     " + tokenizer.sval);
            } else if (tokenizer.TT_NUMBER == tokenizer.ttype) {
                System.out.println("TT_NUMBER:   " + tokenizer.nval);
            } else if ('"' == tokenizer.ttype || '\'' == tokenizer.ttype) {
                // ttype takes quotes to show strings have been input
                System.out.println("String (" + (char) tokenizer.ttype + "):  " + tokenizer.sval);
            } else if (tokenizer.TT_EOL == tokenizer.ttype) {
                System.out.println("TT_EOL");
            } else if (tokenizer.TT_EOF == tokenizer.ttype) {
                System.out.println("TT_EOF");
            } else {
                // it must be a single character
                System.out.println("char:        " + (char) tokenizer.ttype);
            } // switch on token
        } // while( not EOF )
    } // main( String [] )
} // CommandTokenizerDemo.class
